__UNICODE__ equ 1
.586
.model flat,stdcall
option  casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
CreateControls  PROTO   :DWORD
CreateImageList PROTO
EditProc        PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\shell32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\gdi32.lib

include \masm32\macros\macros.asm

.const  
MAXPATH   equ     256*2

SEL	STRUCT
_low     dd      0
_high    dd      0
SEL	ENDS

MainWindowWidth     equ     600
MainWindowHeight    equ     400

SearchWindowWidth   equ     200
BaseSpace           equ     30
StaticHeight        equ     20
ButtonHeight        equ     42

CWUD                equ         CW_USEDEFAULT
WS_COMMON       equ     WS_VISIBLE+WS_CHILD
WS_BUTTON       equ     WS_COMMON+BS_DEFPUSHBUTTON
WS_RBUTTON      equ     WS_COMMON+BS_AUTORADIOBUTTON
WS_CHECKBOX    equ     WS_COMMON+BS_AUTOCHECKBOX
WS_RICHEDIT     equ     WS_COMMON+ES_READONLY+ES_MULTILINE+WS_HSCROLL+WS_VSCROLL
WS_EDIT         equ     WS_COMMON+ES_WANTRETURN+ES_LEFT
WS_STATIC	equ       WS_COMMON+SS_SIMPLE+SS_NOTIFY
WS_TOOLBAR      equ      WS_COMMON+TBSTYLE_FLAT
WS_BOX              equ     WS_COMMON+BS_GROUPBOX

IDB_OPEN	    equ     100h
IDB_WWORD       equ     101h
IDB_MCASE       equ     102h
IDB_FINDN       equ     103h
IDB_FINDP       equ     104h
IDB_CLOSE       equ     105
IDB_ABOUT       equ     106h

RichEditId              equ         1000h
StaticId                equ         1001h
ToolbarId               equ         1002h
EditId                  equ         1003h
MatchWholeWordId        equ         1004h
MatchCaseId             equ         1005h
SearchDownId            equ         1006h
SearchUpId              equ         1007h
SearchId                equ         1008h
NoTBButtons     equ     4
NoBitmaps       equ     3
.data
hInstance       HINSTANCE       ?
hMainWindow     HWND            ?
UCSTR           MainWindowClass, "MainWindowClass",0
UCSTR           MainWindowName,  "FindIn Tool v1.0",0
wcex            WNDCLASSEX      <sizeof wcex,CS_HREDRAW+CS_VREDRAW,offset WndProc,\
                                0,0,?,?,?,COLOR_WINDOW,0,offset MainWindowClass,?>

; ++++ Rich Edit Control related ++++

hRichEdit       HWND            ?
UCSTR           RichEditClass,"RichEdit20A",0
UCSTR           szRichEditLib,"riched20",0
hRichEditLib    dd              ?
EditStream      EDITSTREAM      <?,?,offset StreamInProc>
stex            SETTEXTEX       <ST_SELECTION,1200>
cf              CHARFORMAT      <sizeof CHARFORMAT,CFM_BOLD OR CFM_COLOR,CFE_BOLD,\
                                    0,0,0ff0000h,0,0,<0>>
SearchInProgress        dd              FALSE
SearchStarted           dd              FALSE
                                    
; ++++ Edit Control related ++++

hEdit           HWND            ?
UCSTR           EditClass,"EDIT",0
lpOldEditProc       dd              ?
ft              FINDTEXT        <<0,-1>,offset TextBuffer>
gtlex           GETTEXTLENGTHEX <GTL_NUMCHARS,1200>
SearchFlags       dd          FR_DOWN
TextBuffer      dw      256 dup(0)
cbSearchText    dd          ?
LASTSEL         SEL     <>

; ++++ Toolbar related ++++

hToolbar        HWND            ?
UCSTR           ToolbarClass,"ToolbarWindow32",0
TBButtons       TBBUTTON	   <0,IDB_OPEN,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                    TBBUTTON	               <1,IDB_ABOUT,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                    TBBUTTON	               <0,0,0,TBSTYLE_SEP,0,0>
                    TBBUTTON	               <2,IDB_CLOSE,TBSTATE_ENABLED,BTNS_BUTTON,0,0>

BitmapOffsets       dd          offset szBmpOpen,offset szBmpAbout,offset szBmpClose
UCSTR           szBmpOpen,".\open.bmp",0
UCSTR           szBmpAbout,".\about.bmp",0
UCSTR           szBmpClose,".\close.bmp",0
hIml                dd              ?
                   
; ++++ Buttons related ++++

hOpen           HWND            ?  
hWholeWord      HWND            ?
hMatchCase      HWND        	  ?
hFindNext       HWND            ?
hFindPrev       HWND            ?
hSearchDown HWND            ?
hSearchUp       HWND        	?
hSearchBox     HWND        	?
hSearch          HWND              ?
UCSTR           ButtonClass,"BUTTON",0

; ++++ Static related ++++

hStatic         HWND            ?
UCSTR       StaticClass,"STATIC",0

; ++++ Other Variables ++++

rect            RECT                <>
iccx            INITCOMMONCONTROLSEX        <sizeof iccx,ICC_STANDARD_CLASSES>

; ++++ Strings ++++

UCSTR       szNoText,"---EMPTY---",0
UCSTR       szAboutText,"Programmed by Luis Costa",10,13,"contact:xandaz@hotmail.com",0
UCSTR       szMatchWholeWord,"Match whole word",0
UCSTR       szMatchCase,"Case sensitive",0
UCSTR       szSearchDown,"SearchDown",0
UCSTR       szSearchUp,"Search Up",0
UCSTR       szSearch,"Search",0
UCSTR       szFound,"Text Found!",0
UCSTR       szNotFound,"Text not found!",0
UCSTR       szAttention,"Attention!!!",0
UCSTR       szEmptyString,"                                                         ",0
                                                                               
; ++++ Open File Names and related ++++

ofn             OPENFILENAME        <sizeof ofn,?,?,offset Filters,0,0,0,?,?,offset lpstrFileTitle,sizeof lpstrFileTitle,\
                                                0,offset szOpen,OFN_EXPLORER+OFN_ALLOWMULTISELECT,0,0,0,0,0,0>
lpstrFileTitle      dw      256 dup(0)
UCSTR           Filters,"Include Files",0,"*.inc",0,"SDK Files",0,"*.sdk",0,"All Files",0,"*.*",0,0
UCSTR           szOpen,"Open Files",0
lpMem           dd          	?
lpFile             dd            ?
filePointer     dd              ?
hFile              dd           ?
MoreThanOneFile     dd      FALSE
hFont           HFONT           ?
UCSTR           szTahoma,"Tahoma",0
ONEFILE         dd          ?
FirstFile       dd          ?

.code
    start:
        invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  WinMain,hInstance,0,0,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInst
    pop     wcex.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wcex.hIcon,eax
    mov     wcex.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wcex.hCursor,eax
    invoke  RegisterClassEx,addr wcex
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILED+WS_SYSMENU,\
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,SW_SHOWNORMAL
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop                        
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    uses esi edi hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if     uMsg==WM_CREATE
        mov     edi,lParam
        .if     [edi.CREATESTRUCT].hWndParent==0
            invoke  CreateControls,hWnd
        .endif
    .elseif uMsg==WM_COMMAND
        mov     eax,wParam
        .if     ax==IDB_OPEN
            invoke  LocalFree,lpMem
            invoke  LocalAlloc,LPTR,MAXPATH*256
            mov     lpMem,eax
            mov     ofn.lpstrFile,eax
            mov     ofn.nMaxFile,MAXPATH*1024
            invoke  GetOpenFileName,addr ofn
            mov     esi,lpMem
check_loop_1:
            lodsw
            or      al,al
            jnz     check_loop_1
            lodsw
            or      al,al
            jnz     mtof
            mov     ONEFILE,TRUE
            mov     esi,lpMem
            jmp     loop_1                
mtof:
            mov     ONEFILE,FALSE
            mov     esi,lpMem
            invoke  SetCurrentDirectory,lpMem
            call    align2next
            mov     filePointer,esi
            mov     FirstFile,esi
            invoke  SendMessage,hStatic,WM_SETTEXT,0,esi
loop_1:
            invoke  CreateFile,esi,GENERIC_READ,FILE_SHARE_READ,0, OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,\
                            FILE_FLAG_WRITE_THROUGH
            mov     hFile,eax
            mov     EditStream.dwCookie,eax
            invoke  SendMessage,hRichEdit,EM_STREAMIN,SF_TEXT,addr EditStream
        .elseif ax==IDB_ABOUT
            invoke  ShellAbout,hWnd,addr MainWindowName,addr szAboutText,0            
        .elseif ax==IDB_CLOSE
            jmp     close_app
        .elseif ax==SearchId
            .if     SearchStarted==FALSE
                invoke  SendMessage,hEdit,WM_GETTEXTLENGTH,0,0
                mov     cbSearchText,eax
                invoke  SendMessage,hEdit,WM_GETTEXT,eax,addr TextBuffer
                mov     SearchStarted,TRUE
            .endif                
            invoke  SetTimer,hWnd,0100,10,addr WndProc
        .elseif     ax==SearchUpId
            xor     SearchFlags,FR_DOWN
            mov     ft.chrg.cpMin,-1
            mov     ft.chrg.cpMax,0
        .elseif     ax==SearchDownId
            mov     ft.chrg.cpMax,-1
            mov     ft.chrg.cpMin,0
            or      SearchFlags,FR_DOWN                
        .elseif     ax==MatchWholeWordId
            invoke  SendMessage,hWholeWord,BM_GETSTATE,0,0
            .if    ax==BST_CHECKED
                or      SearchFlags,FR_WHOLEWORD
            .else
                xor     SearchFlags,FR_WHOLEWORD
            .endif                    
        .elseif     ax==MatchCaseId
            invoke  SendMessage,hMatchCase,BM_GETSTATE,0,0
            .if     eax==BST_CHECKED
                or      SearchFlags,FR_WHOLEWORD                                                                                               
            .else
                xor     SearchFlags,FR_WHOLEWORD
            .endif                                        
        .endif                
    .elseif uMsg==WM_TIMER
        .if     wParam==100 
            invoke  SendMessage,hRichEdit,EM_FINDTEXT,SearchFlags,addr ft
            .if     eax==-1
                .if     ONEFILE==FALSE
                    invoke  CloseHandle,hFile
                    mov     esi,filePointer
                    test    SearchFlags,FR_DOWN
                    jz      align_to_prev
                    call    align2next
                    jmp     skip_1
align_to_prev:
                    call    align2prev                
skip_1:                
                    mov     filePointer,esi
                    .if     eax==TRUE
                        invoke  SendMessage,hStatic,WM_SETTEXT,0,addr szEmptyString
                        invoke  SendMessage,hStatic,WM_SETTEXT,0,esi
                        invoke  CreateFile,esi,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,\
                                    FILE_ATTRIBUTE_NORMAL,FILE_FLAG_SEQUENTIAL_SCAN
                        mov     hFile,eax
                        mov     EditStream.dwCookie,eax
                        invoke  SendMessage,hRichEdit,WM_SETTEXT,0,0
                        invoke  SendMessage,hRichEdit,EM_STREAMIN,SF_TEXT,addr EditStream
                    .else
                        invoke  KillTimer,hWnd,100
                    .endif                    
                .endif                    
            .else
                push    eax
                invoke  SendMessage,hRichEdit,EM_SETSEL,LASTSEL._low,LASTSEL._high
                mov     cf.crTextColor,0ff0000h
                invoke  SendMessage,hRichEdit,EM_SETCHARFORMAT,SCF_SELECTION,addr cf
                mov     cf.crTextColor,0ffh
                pop     eax
                mov     ebx,eax
                add     ebx,cbSearchText
                inc     ebx
                mov     LASTSEL._low,eax
                mov     LASTSEL._high,ebx
                invoke  SendMessage,hRichEdit,EM_SETSEL,eax,ebx
                invoke  SendMessage,hRichEdit,EM_SETCHARFORMAT,SCF_SELECTION,addr cf
                mov     ft.chrg.cpMin,ebx
                invoke  KillTimer,hWnd,100
            .endif                                                                                                                         
        .endif          
    .elseif uMsg==WM_DESTROY
close_app:
        invoke  LocalFree,lpMem
        invoke  PostQuitMessage,NULL
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor     eax,eax
    ret

WndProc     endp                                                

CreateControls  PROC    hWnd:DWORD

            invoke  CreateFont,16,8,0,0,FW_THIN,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,\
                            CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH+FF_DECORATIVE,addr szTahoma
            mov     hFont,eax                            
            invoke  InitCommonControlsEx,addr iccx
            invoke  LoadLibrary,addr szRichEditLib
            mov     hRichEditLib,eax
            invoke  GetClientRect,hWnd,addr rect
            push    rect.right
            sub     rect.right,SearchWindowWidth+2
            push    rect.bottom
            sub     rect.bottom,StaticHeight+ButtonHeight+4
            push    rect.top
            add     rect.top,ButtonHeight+2
            invoke  CreateWindowEx,WS_EX_CLIENTEDGE,addr RichEditClass,addr szNoText,WS_RICHEDIT,\
                        0,rect.top,rect.right,rect.bottom,hWnd,RichEditId,hInstance,0
            mov     hRichEdit,eax
            invoke  SendMessage,eax,WM_SETFONT,hFont,TRUE
            invoke  SendMessage,hRichEdit,EM_SETCHARFORMAT,SCF_ALL,addr cf
            mov     cf.crTextColor,0ffh
            pop     rect.top
            pop     rect.bottom
            pop     rect.right
            mov     eax,rect.bottom
            sub     eax,StaticHeight+2
            push    rect.top
            mov     rect.top,eax
            invoke  CreateWindowEx,WS_EX_STATICEDGE,addr StaticClass,0,WS_STATIC,\
                            0,rect.top,rect.right,20,hWnd,StaticId,hInstance,0
           mov     hStatic,eax                            
           invoke   SendMessage,eax,WM_SETFONT,hFont,TRUE
           invoke   CreateWindowEx,0,addr ToolbarClass,0,WS_TOOLBAR,\
                        CWUD,CWUD,CWUD,CWUD,hWnd,ToolbarId,hInstance,0
            mov     hToolbar,eax                        
            invoke  CreateImageList
            invoke  SendMessage,hToolbar,TB_SETIMAGELIST,0,hIml
            invoke  SendMessage,hToolbar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0
            invoke  SendMessage,hToolbar,TB_ADDBUTTONS,NoTBButtons,addr TBButtons
            invoke  SendMessage,hToolbar,TB_AUTOSIZE,0,0
            pop     rect.top
            mov     eax,rect.right
            sub     eax,SearchWindowWidth
;            push    rect.left
            mov     rect.left,eax
            sub     rect.bottom,ButtonHeight+StaticHeight+4
            invoke  CreateWindowEx,0,addr ButtonClass,addr szSearch,WS_BOX,\
                            rect.left,ButtonHeight+2,SearchWindowWidth-2,rect.bottom,hWnd,\
                            0,hInstance,0
            mov     hSearchBox,eax                                                                    
            invoke  SendMessage,eax,WM_SETFONT,hFont,TRUE
            add     rect.left,10
            invoke  CreateWindowEx,WS_EX_CLIENTEDGE,addr EditClass,0,WS_EDIT,\
                            rect.left,ButtonHeight+2+BaseSpace,SearchWindowWidth-20,24,hWnd,EditId,hInstance,0
            mov     hEdit,eax          
            invoke  SendMessage,eax,WM_SETFONT,hFont,TRUE
            invoke  SetWindowLong,hEdit,GWL_WNDPROC,addr EditProc
            mov     lpOldEditProc,eax
            invoke  CreateWindowEx,0,addr ButtonClass,addr szMatchWholeWord,WS_CHECKBOX,\
                            rect.left,ButtonHeight+2+40+BaseSpace,SearchWindowWidth-20,20,hWnd,MatchWholeWordId,hInstance,0
            mov     hWholeWord,eax                                         
            invoke  SendMessage,eax,WM_SETFONT,hFont,TRUE   
            mov     eax,rect.left
            add     eax,SearchWindowWidth/2
            invoke  CreateWindowEx,0,addr ButtonClass,addr szMatchCase,WS_CHECKBOX,\
                            rect.left,ButtonHeight+2+70+BaseSpace,SearchWindowWidth-20,20,hWnd,MatchCaseId,hInstance,0
            mov     hMatchCase,eax                                
            invoke  SendMessage,eax,WM_SETFONT,hFont,TRUE
            invoke  CreateWindowEx,0,addr ButtonClass,addr szSearchDown,WS_RBUTTON,\
                            rect.left,ButtonHeight+2+100+BaseSpace,SearchWindowWidth-20,20,hWnd,SearchDownId,hInstance,0
            mov     hSearchDown,eax
            invoke  SendMessage,eax,WM_SETFONT,hFont,TRUE
            invoke  CreateWindowEx,0,addr ButtonClass,addr szSearchUp,WS_RBUTTON,\
                            rect.left,ButtonHeight+2+130+BaseSpace,SearchWindowWidth-20,20,hWnd,SearchDownId,hInstance,0
            mov     hSearchUp,eax
            invoke  SendMessage,eax,WM_SETFONT,hFont,TRUE
            invoke  SendMessage,hSearchDown,BM_SETCHECK,BST_CHECKED,0            
            or          SearchFlags,FR_DOWN
            invoke  CreateWindowEx,0,addr ButtonClass,addr szSearch,WS_BUTTON+BS_CENTER,\
                            rect.left,ButtonHeight+2+160+BaseSpace,SearchWindowWidth-20,32,hWnd,SearchId,hInstance,0
            mov     hSearch,eax
            invoke  SendMessage,eax,WM_SETFONT,hFont,TRUE                            
            ret

CreateControls  endp

CreateImageList PROC

        invoke  ImageList_Create,32,32,ILC_COLOR16+ILC_MASK,3,3
        mov     hIml,eax
        lea       esi,BitmapOffsets
        mov     ecx,NoBitmaps
loop_1:
        push    ecx
        invoke  LoadImage,hInstance,dword ptr [esi],IMAGE_BITMAP,32,32,LR_LOADFROMFILE+LR_LOADMAP3DCOLORS+LR_LOADTRANSPARENT
        add     esi,4
        invoke  ImageList_AddMasked,hIml,eax,0
        pop     ecx
        dec     ecx
        jcxz        end_loop_1
        jmp     loop_1
end_loop_1:
        ret

CreateImageList endp                

StreamInProc    PROC    File:DWORD,lpBuff:DWORD,cb:DWORD,pcb:DWORD

        invoke  ReadFile,File,lpBuff,cb,pcb,0
        xor     eax,eax
        ret
        
StreamInProc    endp

align2next      PROC

        pushfd
        cld
loop_1:
        lodsw
        or      al,al
        jnz     loop_1
        push    esi
        lodsw
        or      al,al
        jz      no_more_files
        pop     esi
        popfd
        mov     eax,TRUE
        ret
no_more_files:
        pop     esi
        popfd
        mov     eax,FALSE
        ret        

align2next      endp                

align2prev  PROC

        pushfd
        std
        cmp     esi,FirstFile
        jbe     no_more_files            
loop_1:
        lodsw
        or      ah,ah
        jnz     loop_1        
        add     esi,2
        mov     eax,TRUE
        popfd
        ret
no_more_files:  
        popfd
        mov     eax,FALSE
        ret

align2prev  endp       
OfnHookProc     PROC        hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

        .if     uMsg==CDN_FILEOK
            invoke  Beep,200,20
            mov     esi,lParam
            assume  esi:PTR OFNOTIFY
            cld
loop_1: 
            lodsw
            or      al,al
            jnz     loop_1
loop_2:
            lodsw
            or      al,al
            jz      one_file
            mov     MoreThanOneFile,TRUE
            jmp     one_file
one_file:

        .endif                        
            ret
                                                                                                
OfnHookProc     endp

EditProc        PROC        hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

        .if     uMsg==WM_CHAR
            .if     wParam==VK_RETURN
                mov     ax,BN_CLICKED
                shl       eax,16                
                mov     ax,SearchId
                invoke  SendMessage,hMainWindow,WM_COMMAND,eax,0
            .else                
                invoke  CallWindowProc,lpOldEditProc,hWnd,uMsg,wParam,lParam
            .endif
        .else
            invoke  CallWindowProc,lpOldEditProc,hWnd,uMsg,wParam,lParam
        .endif
        ret
                                                
EditProc        endp
end     start